# -*- coding: utf-8 -*-
"""
Created on Mon Apr 18 17:18:29 2022

@author: conmc
"""
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy.sparse

df_items=pd.read_csv('items.csv',delimiter='|')
df_orders=pd.read_csv('orders.csv',delimiter='|')
df_categories=pd.read_csv('category_hierarchy.csv',delimiter='|')

num_orders=df_orders['userID'].value_counts()
num_orders.plot.hist(bins=278) # indicates vast majority of users made between 5 and 50 orders

user_percentile=[sum(num_orders<i)/sum(num_orders>0) for i in range(1,279)]
plt.plot(range(1,279),user_percentile)
plt.show(block=True)

#%%
# try creating the adjacency matrix for the items, based on shared categories
# also try creating the tree generated by the category_hierarchy.csv
# then use matplotlib.pyplot.path() to visualize both (?)

N_items=max(df_items.iloc[:,0])
item_groups=df_items.groupby('feature_1').groups
ind_rows=[]
ind_cols=[]
for k in range(-1,10):
    temp=list(item_groups[k])
    n_temp=np.size(temp)
    for i in temp:
        temp.remove(i)
        for j in range(0,n_temp-1):
            ind_rows.append(i)
            ind_cols.append(temp[j])
        temp.append(i)

ind_rows=np.array(ind_rows)
ind_cols=np.array(ind_cols)
#%%
# n_indices=np.size(ind_rows)
# A=scipy.sparse.coo_matrix((np.ones(n_indices),(np.array(ind_rows),np.array(ind_cols))),shape=[N_items+1,N_items+1])
# the matrix A is over 2GB in size... too large to store or compute with

# N_items=10
# data=[]
# ind_row=[]
# ind_col=[]
# for i in range(0,N_items):
#     item_i = df_items.iloc[i,range(2,7)]
#     for j in range(i+1,N_items):
#         item_j = df_items.iloc[j,range(2,7)]
#         datum = sum(item_i==item_j)
#         if datum>0:
#             data.append(datum)
#             ind_row.append(i)
#             ind_col.append(j)
        
# A=scipy.sparse.coo_matrix((data,(ind_row,ind_col)),shape=[N_items,N_items])
# matplotlib.pyplot.spy(A)
        
#%%
# still trying to figure out how to pick out specific rows of df_order based on number of orders per customer
dummy_orders=df_orders.groupby('userID').sum()['order']
